/*----------------------------------------------------------------------------*/
/*
    : loops.c
    : 
     :  .., .
      : 11.03.08-13:35
*/
/*----------------------------------------------------------------------------*/
#ifndef loops_c_E
#define loops_c_E
/*----------------------------------------------------------------------------*/
// #define DEBUGLEVEL 3
/*----------------------------------------------------------------------------*/
#include <aforth.h>
/*----------------------------------------------------------------------------*/
/*     begin */
void stdword_begin(struct fws* ws)
    {
	struct vcode v={0,0};
	// ,     
	if(!(ws->flags & FWS_COMPILE)){SETERROR(ws,AFER_COMPONLY);return;}
	//
	v.type = WTYPE_NATIVE | FCMD_BEGIN;
	v.word = find_nword(ws, "begin_run");
	//
	if(do_compile_add(ws, &v)>=0){if(to_sstk(ws, v.type)<0){SETERROR(ws,AFER_SSTKOVF);}}
	//
	dmsg("begin : 0x%x 0x%x\n",v.type,v.word);
    }
/*----------------------------------------------------------------------------*/
/*     begin */
void stdword_begin_run(struct fws* ws)
    {
	to_rstk(ws, ws->ccmd);
	dmsg("begin(rt) : 0x%x\n",ws->ccmd);
    }
/*----------------------------------------------------------------------------*/
/*     until */
void stdword_until(struct fws* ws)
    {
	struct vcode v={0,0};
	int mean;
	int ret=from_sstk(ws, &mean);
	//
	if((ret<0)||((mean&FCMD_MASK)!=FCMD_BEGIN)){SETERROR(ws,AFER_UNTILWB);return;}
	//
	v.type = WTYPE_NATIVE | FCMD_UNTIL;
	v.word = find_nword(ws, "until_run");
	//
	do_compile_add(ws, &v);
	//
	dmsg("until : 0x%x 0x%x\n",v.type,v.word);
    }
/*----------------------------------------------------------------------------*/
/*     until */
void stdword_until_run(struct fws* ws)
    {
	vcode v1;
	vcode* radr;
	if(get_local_copy(ws,&v1)<0){return;}
	//
	if(from_rstk(ws, &radr)<0){return;}
	//
	if(!(v1.ivar)){ws->rcode=radr;}
	//
	clear_vcode(&v1);
    }
/*----------------------------------------------------------------------------*/
/*     while */
void stdword_while(struct fws* ws)
    {
	struct vcode v={0,0};
	int mean;
	int ret=from_sstk(ws, &mean);
	//
	if((ret<0)||((mean&FCMD_MASK)!=FCMD_BEGIN)){SETERROR(ws,AFER_WHILEWB);return;}
	//
	v.type = WTYPE_NATIVE | FCMD_WHILE;
	v.word = find_nword(ws, "while_run");
	//
	if(do_compile_add(ws, &v)>=0){if(to_sstk(ws, v.type)<0){SETERROR(ws,AFER_SSTKOVF);}}
	//
	dmsg("while : 0x%x 0x%x\n",v.type,v.word);
    }
/*----------------------------------------------------------------------------*/
/*
      ,  
*/
void stdword_loop_pass_to(vcode** cmd)
    {
	int level=0;
	int ex=0;
	while(1)
	    {
		switch(GETFASTCMD(*cmd))
		    {
			case FCMD_BEGIN: {level++;break;}
			case FCMD_UNTIL: 
			case FCMD_REPEAT:
			    {
				if(!level){ex=1;}else{level--;}
			        break;
			    }
		    }
		//
		if(ex){break;}
		(*cmd)++;
	    }
    }
/*----------------------------------------------------------------------------*/
/*     while */
void stdword_while_run(struct fws* ws)
    {
	vcode v1;
	vcode* radr;
	if(get_local_copy(ws,&v1)<0){return;}
	//     -      
	//   .
	dmsg("while (rt): %i\n",v1.ivar);
	if(!(v1.ivar))
	    {
		vcode* cmd=(ws->ccmd)+1;
		if(from_rstk(ws, &radr)<0){clear_vcode(&v1);return;}
		//
		stdword_loop_pass_to(&cmd);
		//
		ws->rcode = cmd+1;
	    }
	clear_vcode(&v1);
    }
/*----------------------------------------------------------------------------*/
/*     repeat */
void stdword_repeat(struct fws* ws)
    {
	struct vcode v={0,0};
	int mean;
	int ret=from_sstk(ws, &mean);
	//
	if((ret<0)||((mean&FCMD_MASK)!=FCMD_WHILE)){SETERROR(ws,AFER_REPEATWB);return;}
	//
	v.type = WTYPE_NATIVE | FCMD_REPEAT;
	v.word = find_nword(ws, "repeat_run");
	//
	do_compile_add(ws, &v);
	//
	dmsg("repeat : 0x%x 0x%x\n",v.type,v.word);
    }
/*----------------------------------------------------------------------------*/
/*     repeat */
void stdword_repeat_run(struct fws* ws)
    {
	vcode* radr;
	if(from_rstk(ws, &radr)<0){return;}
	ws->rcode=radr;
    }
/*----------------------------------------------------------------------------*/
#endif /* loops_c_E */
