/*----------------------------------------------------------------------------*/
/*
    : save.c
    :  
     :  .., .
      : 22.07.08-22:36
*/
/*----------------------------------------------------------------------------*/
#ifndef save_c_E
#define save_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
/*----------------------------------------------------------------------------*/
void stdword_save_str(char* s, FILE* f)
    {
	fprintf(f,"\"");
	while(*s)
	    {
		switch(*s)
		    {
			case '\n':{fprintf(f,"\\n");break;}
			case '\r':{fprintf(f,"\\r");break;}
			case '\t':{fprintf(f,"\\t");break;}
			case '\\':{fprintf(f,"\\\\");break;}
			default:{putc(*s,f);}
		    }
		s++;
	    }
	fprintf(f,"\" ");
    }
/*----------------------------------------------------------------------------*/
void stdword_save_tabs(int n, FILE* f){int i;for(i=0;i<n;i++){fprintf(f,"    ");}}
/*----------------------------------------------------------------------------*/
/*
    
*/
void stdword_save(struct fws* ws)
    {
	one_op_pramble();
	if(v1.type!=WTYPE_CSTR){SETERROR(ws,AFER_INVTYPES);}
	else
	    {
		FILE* f=fopen(v1.svar,"w+");
		clear_vcode(&v1);
		v1.type=WTYPE_CINT;
		if(f){v1.ivar=0;}else{v1.ivar=-1;}
		to_vstk(ws, &v1);
		//  
		if(f)
		    {
			struct fword* dict=ws->dict;
			struct vcode* vcd;
			int i;
			for(i=0;i<(ws->dict_size);i++)
			    {
				switch (GTYPE(dict))
				    {
					case WTYPE_VIRTUAL:
					    {
						fprintf(f,"( -: %s )\n",dict->name);
						fprintf(f,": %s ",dict->name);
						vcd=dict->vmcode;
						int tabs=0;
						while (GETFASTCMD(vcd)!=FCMD_ENDVM)
						    {
							if(GETFASTCMD(vcd))
							    {
								//  
								fprintf(f,"\n");
								switch (GETFASTCMD(vcd))
								    {
									case FCMD_IF:	 {stdword_save_tabs(tabs++,f);fprintf(f,"if\n");break;}
									case FCMD_ELSE:	 {stdword_save_tabs(--tabs,f);tabs++;fprintf(f,"else\n");break;}
									case FCMD_ENDIF: {stdword_save_tabs(--tabs,f);fprintf(f,"endif\n");break;}
									case FCMD_BEGIN: {stdword_save_tabs(tabs++,f);fprintf(f,"begin\n");break;}
									case FCMD_UNTIL: {stdword_save_tabs(--tabs,f);fprintf(f,"until\n");break;}
									case FCMD_WHILE: {stdword_save_tabs(--tabs,f);tabs++;fprintf(f,"while\n");break;}
									case FCMD_REPEAT:{stdword_save_tabs(--tabs,f);fprintf(f,"repeat\n");break;}
								    }
								stdword_save_tabs(tabs,f);
							    }
							else switch (GTYPE(vcd))
							    {
								// 
								case WTYPE_CINT:
								    {
									fprintf(f,"%i ",vcd->ivar);
									break;
								    }
								case WTYPE_CREAL:
								    {
									fprintf(f,"%g ",vcd->fvar);
									break;
								    }
								case WTYPE_CSTR:
								    {
									stdword_save_str(vcd->svar, f);
									break;
								    }
								default:
								    {
									fprintf(f,"%s ",ws->dict[vcd->word].name);
								    }
							    }
							vcd++;
						    }
						fprintf(f,";\n");
						break;
					    }
					case WTYPE_INT:
					    {
						fprintf(f,"(  : %s )\n",dict->name);
						fprintf(f,"%i variable %s\n",dict->ivar,dict->name);
						break;
					    }
					case WTYPE_REAL:
					    {
						fprintf(f,"(  : %s )\n",dict->name);
						fprintf(f,"%f variable %s\n",dict->fvar,dict->name);
						break;
					    }
					case WTYPE_STR:
					    {
						fprintf(f,"(  : %s )\n",dict->name);
						stdword_save_str(dict->svar, f);
						fprintf(f," variable %s\n",dict->name);
						break;
					    }
					case WTYPE_ARRAY:
					    {
						int col=0;
						int i;
						fprintf(f,"( : %s )\n{ byte\n    ",dict->name);
						for(i=0;i<dict->size;i++)
						    {
							if(col>=0x10){fprintf(f,"\n    ");col=0;}col++;
							fprintf(f,"0x%.2X ",((unsigned char*)(dict->svar))[i]);
						    }
						fprintf(f,"\n} array %s\n",dict->name);
						break;
					    }
				    }
				dict++;
			    }
			fclose(f);
		    }
	    }
	clear_vcode(&v1);
    }
/*----------------------------------------------------------------------------*/
#endif /* save_c_E */
