/*----------------------------------------------------------------------------*/
/*
    : aforth.h
    :  
     :  .., .
      : 06.03.08-21:19
*/
/*----------------------------------------------------------------------------*/
#ifndef aforth_h_E
#define aforth_h_E
/*----------------------------------------------------------------------------*/
/*
     
*/
#define WORD_CONSTARRAY	(1<<8)	/*        */
//
#define WORD_CONST	(1<<7)
#define WORD_ICONST	(1<<6)
// 
#define WTYPE_NATIVE	(1<<5)
#define WTYPE_VIRTUAL	(1<<4)
//  
#define WTYPE_INT	(1<<0)	/*   */
#define WTYPE_REAL	(2<<0)	/*  */
#define WTYPE_STR	(3<<0)	/*  */
#define WTYPE_ARRAY	(4<<0)	/*  */
//     
#define VARTYPES_MASK	0x0F

// 
#define WTYPE_CINT	(WTYPE_INT | WORD_CONST)
#define WTYPE_CREAL	(WTYPE_REAL | WORD_CONST)
#define WTYPE_CSTR	(WTYPE_STR | WORD_CONST)
#define WTYPE_CARRAY	(WTYPE_ARRAY | WORD_CONST)
//  
#define GTYPE(f)	(((f)->type) & 0xFF)
//  ,   
#define GTYPEC(f)	(((f)->type) & (0xFF & ~(WORD_CONST)))
#define GTYPEI(f)	(((f)->type) & (0xFF & ~(WORD_ICONST)))
#define GTYPECI(f)	(((f)->type) & (0xFF & ~(WORD_ICONST|WORD_CONST)))
//  ?
#define ISCONST(f)	(((f)->type) & WORD_CONST)

#define ISICONST(f)	(((f)->type) & WORD_ICONST)
#define ISANYCONST(f)	(f&(WORD_CONST|WORD_ICONST))
//  
#define STYPE(f,t)	{((f)->type) = (((f)->type) & ~0xFF) | (t & 0xFF);}
//
#define SETWRD(w)	((int)(w))
/*----------------------------------------------------------------------------*/
struct fword;
struct fws;
/*----------------------------------------------------------------------------*/
/*
          .
*/
typedef struct vcode
    {
	unsigned int  type;
	union		//  (   )
	    {
		int   word; //    WORD_CONST,      
		int   ivar; //  
		float fvar; //  
		char* svar; //  
	    };
    }vcode;
/*----------------------------------------------------------------------------*/
/*
     .
*/
typedef struct fword
    {
	char* name;
	unsigned int type;
	union		     //  (   )
	    {
		int   ivar; // 
		float fvar; // 
		char* svar; // 
		struct vcode* vmcode; //   
		void (*ncode)(struct fws* ws); //    
	    };
	int size;	    //   (    )
    }fword;
/*----------------------------------------------------------------------------*/
/*
     
*/
#define VSTK_SIZE	0x40	/*  . */
#define RSTK_SIZE	0x20	/*  . */
#define SSTK_SIZE	0x20	/*  . */
#define MAX_DEEP	0x40	/*    . */
/*----------------------------------------------------------------------------*/
/*
      .
*/
#define	FWS_COMPILE	(1<<0)	/*   */
#define	FWS_CONSTARRAY	(1<<1)	/* ,  ģ  - */
/*----------------------------------------------------------------------------*/
#define MAXLINESIZE	0x100
/*----------------------------------------------------------------------------*/
typedef struct fws
    {
	/*  */
	struct fword* dict;
	int dict_size;
	/*   */
	struct vcode* vstk;
	int vstk_top;
	/*
	     .
	         
	    .
	*/
	struct vcode** rstk;
	int rstk_top;
	/*  . */
	unsigned int* sstk;
	int sstk_top;
	/*  */
	unsigned int flags;
	/*  . */
	int error;
	/*     */
	char	inbuf[MAXLINESIZE]; // ,    .
	char*	curchar; //    .
	union		//  (     )
	    {
		int   word; //    
		int   ivar; //  
		float fvar; //  
		char* svar; //  
		char* unknown; //  
	    };
	/*  */
	struct fword* cword; 	//   .
	void*	array;		//     .  sizeof(int) -  .
	int	arr_int_sz;	//      (byte, short, int)
	// 
	struct vcode* rcode; //       
	struct vcode* ccmd; //    
	int procdeep; //   .      .
	int rem_counter; // ޣ   ( 0,   )
    }fws;
/*----------------------------------------------------------------------------*/
#define SETERROR(ws,err)	{ws->error = err;}
/*----------------------------------------------------------------------------*/
/*
     
*/
// 
#define FCMD_IF		(0x01 << 8)
#define FCMD_ELSE	(0x02 << 8)
#define FCMD_ENDIF	(0x03 << 8)
// 
#define FCMD_BEGIN	(0x04 << 8)
#define FCMD_UNTIL	(0x05 << 8)
#define FCMD_WHILE	(0x06 << 8)
#define FCMD_REPEAT	(0x07 << 8)
//
#define FCMD_DO		(0x08 << 8)
#define FCMD_LOOP	(0x09 << 8)
#define FCMD_AGAIN	(0x0A << 8)
#define FCMD_LEAVE	(0x0B << 8)
//   
#define FCMD_ENDVM	(0xFF << 8)
#define FCMD_MASK	(0xFF << 8)
//
#define GETFASTCMD(f)	((f)->type & (0xFF << 8))
#define SETFASTCMD(f,cmd) {(f)->type  = cmd;}
//    -
#define	INTERP_ONLY	(0x10 << 8) /*   . ,    */
/*----------------------------------------------------------------------------*/
#include <aconfig.h>
#include <rstk.h>
#include <vstk.h>
#include <sstk.h>
#include <wspc.h>
#include <dict.h>
#include <inpstream.h>
#include <interp.h>
#include <compil.h>
#include <vm.h>
#include <wrdmacro.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <errors.h>
/*----------------------------------------------------------------------------*/
#endif /* aforth_h_E */
