/*----------------------------------------------------------------------------*/
/*
    : debug.h
    :  
     :  .., .
      : 06.02.08-21:07
*/
/*----------------------------------------------------------------------------*/
#ifndef debug_h_E
#define debug_h_E
/*----------------------------------------------------------------------------*/
#include <stdio.h>
#include <aforth.h>
/*----------------------------------------------------------------------------*/
#if DEBUGLEVEL>0
#define dmsg(m...) {fprintf(stderr,m);}
#define ldmsg(level,m...) {if(level>=DEBUGLEVEL){fprintf(stderr,m);}}
#else
#define dmsg(m...)
#define ldmsg(level,m...)
#endif
/*----------------------------------------------------------------------------*/
typedef struct edsc
    {
	int code;
	char* str;
    }edsc;
/*----------------------------------------------------------------------------*/
#define AFER_NOERRORS	0x00
#define AFER_RSTKOVF	0x01
#define AFER_VSTKOVF	0x02
#define AFER_SSTKOVF	0x03
#define AFER_RSTKEMPTY	0x04
#define AFER_VSTKEMPTY	0x05
#define AFER_SSTKEMPTY	0x06
#define AFER_NOMEMORY	0x07
#define AFER_UWORD	0x08
#define AFER_USEDWORD	0x09
#define AFER_INVTYPES	0x0A
#define AFER_OPUNDTYPES	0x0B
#define AFER_NOTVAR	0x0C
#define AFER_COMPONLY	0x0D
#define AFER_INTERPONLY	0x0E

#define AFER_ELSEWIF	0x0F
#define AFER_ENDIFWIF	0x10

#define AFER_STATEMENT	0x11

#define AFER_UNTILWB	0x12
#define AFER_WHILEWB	0x13
#define AFER_REPEATWB	0x14

#define AFER_DEEPOVF	0x15

#define AFER_FNOTOPEN	0x16
/*----------------------------------------------------------------------------*/
#ifdef debug_c_E
edsc error_strings[]=
    {
	AFER_NOERRORS,	" ",
	
	AFER_RSTKOVF,	"  ",
	AFER_VSTKOVF,	"  ",
	AFER_SSTKOVF,	"  ",
	
	AFER_RSTKEMPTY,	"  ",
	AFER_VSTKEMPTY,	"  ",
	AFER_SSTKEMPTY,	"  ",
	
	AFER_NOMEMORY,	"  ",
	
	AFER_UWORD,	" ",
	AFER_USEDWORD,	"  ",
	AFER_INVTYPES,  "  ",
	AFER_OPUNDTYPES,"      ",
	AFER_NOTVAR,	"   ",
	AFER_COMPONLY,	"      ",
	AFER_INTERPONLY,"      ",
	
	AFER_ELSEWIF,	"ELSE  IF",
	AFER_ENDIFWIF,	"ENDIF  IF",
	AFER_STATEMENT,	"  ",
	AFER_UNTILWB,	"UNTIL  BEGIN",
	AFER_WHILEWB,	"WHILE  BEGIN",
	AFER_REPEATWB,	"REPEAT  BEGIN",
	AFER_DEEPOVF,	"  ",
	AFER_FNOTOPEN,	"   ",
	//
	-1,NULL
    };
#endif
/*----------------------------------------------------------------------------*/
void dbg_verbose(int code);
void dbg_wordinfo(fword* word);
char* dbg_strerror(int code);
/*----------------------------------------------------------------------------*/
#endif /* debug_h_E */
